diff --git a/drivers/gpu/drm/v3d/v3d_submit.c b/drivers/gpu/drm/v3d/v3d_submit.c
index 2c4bb39c9ac6..a2e55ba8222b 100644
--- a/drivers/gpu/drm/v3d/v3d_submit.c
+++ b/drivers/gpu/drm/v3d/v3d_submit.c
@@ -647,16 +647,65 @@ v3d_get_cpu_copy_query_results_params(struct drm_file *file_priv,
 	return err;
 }
 
+static int
+copy_query_info(struct v3d_performance_query_info *qinfo,
+		unsigned int count,
+		unsigned int nperfmons,
+		u32 __user *syncs,
+		u64 __user *kperfmon_ids,
+		struct drm_file *fpriv)
+{
+	unsigned int i, j;
+	int err;
+
+	for (i = 0; i < count; i++) {
+		struct v3d_performance_query *query = &qinfo->queries[i];
+		u32 __user *ids_pointer;
+		u32 sync, id;
+		u64 ids;
+
+		if (get_user(sync, syncs++)) {
+			err = -EFAULT;
+			goto error;
+		}
+
+		if (get_user(ids, kperfmon_ids++)) {
+			err = -EFAULT;
+			goto error;
+		}
+
+		ids_pointer = u64_to_user_ptr(ids);
+
+		for (j = 0; j < nperfmons; j++) {
+			if (get_user(id, ids_pointer++)) {
+				err = -EFAULT;
+				goto error;
+			}
+
+			query->kperfmon_ids[j] = id;
+		}
+
+		query->syncobj = drm_syncobj_find(fpriv, sync);
+		if (!query->syncobj) {
+			err = -ENOENT;
+			goto error;
+		}
+	}
+
+	return 0;
+
+error:
+	__v3d_performance_query_info_free(qinfo, i);
+	return err;
+}
+
 static int
 v3d_get_cpu_reset_performance_params(struct drm_file *file_priv,
 				     struct drm_v3d_extension __user *ext,
 				     struct v3d_cpu_job *job)
 {
-	u32 __user *syncs;
-	u64 __user *kperfmon_ids;
 	struct drm_v3d_reset_performance_query reset;
 	struct v3d_performance_query_info *qinfo = &job->performance_query;
-	unsigned int i, j;
 	int err;
 
 	if (!job) {
@@ -683,50 +732,17 @@ v3d_get_cpu_reset_performance_params(struct drm_file *file_priv,
 	if (!qinfo->queries)
 		return -ENOMEM;
 
-	syncs = u64_to_user_ptr(reset.syncs);
-	kperfmon_ids = u64_to_user_ptr(reset.kperfmon_ids);
+	err = copy_query_info(qinfo, reset.count, reset.nperfmons,
+			      u64_to_user_ptr(reset.syncs),
+			      u64_to_user_ptr(reset.kperfmon_ids),
+			      file_priv);
+	if (err)
+		return err;
 
-	for (i = 0; i < reset.count; i++) {
-		u32 sync;
-		u64 ids;
-		u32 __user *ids_pointer;
-		u32 id;
-
-		if (get_user(sync, syncs++)) {
-			err = -EFAULT;
-			goto error;
-		}
-
-		if (get_user(ids, kperfmon_ids++)) {
-			err = -EFAULT;
-			goto error;
-		}
-
-		ids_pointer = u64_to_user_ptr(ids);
-
-		for (j = 0; j < reset.nperfmons; j++) {
-			if (get_user(id, ids_pointer++)) {
-				err = -EFAULT;
-				goto error;
-			}
-
-			qinfo->queries[i].kperfmon_ids[j] = id;
-		}
-
-		qinfo->queries[i].syncobj = drm_syncobj_find(file_priv, sync);
-		if (!qinfo->queries[i].syncobj) {
-			err = -ENOENT;
-			goto error;
-		}
-	}
 	qinfo->count = reset.count;
 	qinfo->nperfmons = reset.nperfmons;
 
 	return 0;
-
-error:
-	__v3d_performance_query_info_free(qinfo, i);
-	return err;
 }
 
 static int
@@ -734,11 +750,8 @@ v3d_get_cpu_copy_performance_query_params(struct drm_file *file_priv,
 					  struct drm_v3d_extension __user *ext,
 					  struct v3d_cpu_job *job)
 {
-	u32 __user *syncs;
-	u64 __user *kperfmon_ids;
 	struct drm_v3d_copy_performance_query copy;
 	struct v3d_performance_query_info *qinfo = &job->performance_query;
-	unsigned int i, j;
 	int err;
 
 	if (!job) {
@@ -768,42 +781,13 @@ v3d_get_cpu_copy_performance_query_params(struct drm_file *file_priv,
 	if (!qinfo->queries)
 		return -ENOMEM;
 
-	syncs = u64_to_user_ptr(copy.syncs);
-	kperfmon_ids = u64_to_user_ptr(copy.kperfmon_ids);
+	err = copy_query_info(qinfo, copy.count, copy.nperfmons,
+			      u64_to_user_ptr(copy.syncs),
+			      u64_to_user_ptr(copy.kperfmon_ids),
+			      file_priv);
+	if (err)
+		return err;
 
-	for (i = 0; i < copy.count; i++) {
-		u32 sync;
-		u64 ids;
-		u32 __user *ids_pointer;
-		u32 id;
-
-		if (get_user(sync, syncs++)) {
-			err = -EFAULT;
-			goto error;
-		}
-
-		if (get_user(ids, kperfmon_ids++)) {
-			err = -EFAULT;
-			goto error;
-		}
-
-		ids_pointer = u64_to_user_ptr(ids);
-
-		for (j = 0; j < copy.nperfmons; j++) {
-			if (get_user(id, ids_pointer++)) {
-				err = -EFAULT;
-				goto error;
-			}
-
-			qinfo->queries[i].kperfmon_ids[j] = id;
-		}
-
-		qinfo->queries[i].syncobj = drm_syncobj_find(file_priv, sync);
-		if (!qinfo->queries[i].syncobj) {
-			err = -ENOENT;
-			goto error;
-		}
-	}
 	qinfo->count = copy.count;
 	qinfo->nperfmons = copy.nperfmons;
 	qinfo->ncounters = copy.ncounters;
@@ -815,10 +799,6 @@ v3d_get_cpu_copy_performance_query_params(struct drm_file *file_priv,
 	job->copy.stride = copy.stride;
 
 	return 0;
-
-error:
-	__v3d_performance_query_info_free(qinfo, i);
-	return err;
 }
 
 /* Whenever userspace sets ioctl extensions, v3d_get_extensions parses data